﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sets
{
    public static class BasicSetOperations
    {
        public static ISet<T> Union<T>(params ISet<T>[] arguments)
        {
            return new HashSet<T>(arguments.SelectMany(arg => arg));
        }

        public static ISet<T> Intersect<T>(params ISet<T>[] arguments)
        {
            return new HashSet<T>(arguments.Aggregate((arg1, arg2) => new HashSet<T>(arg1.Intersect(arg2))));
        }
    }
}
